<!DOCTYPE html>
<html> 
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf8">
	<title>5 Flüsse, Kontinest join table</title> 
</head>
<STYLE TYPE="text/css">
	body th, td
	{
		font-family:Arial, sans-serif;
	}
</STYLE>
<body>
<?php

	require("functions.php");
	const showSQL = 1;

	// Verbindung zur Datenbank, sie liegt lokalauf dem Rechner, User ist root, Passwort ist nicht definiert, Name der Datenbank ist hier datenbank
	$conn = new mysqli( 'localhost', 'root','', 'erstedatenbank' );

	if ($conn->connect_error) {
		printf("Verbindungsfehler: %s\n", $conn->connect_error);
		exit();
	}

	// Bei Umlauten ist der korrekte Zeichensatz dringend notwendig!
	$sql_r = $conn->query("SET NAMES 'utf8'");
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
		
	const TableName = 'TempTable';
	
	$sql = "DROP TABLE IF EXISTS ".TableName." \n";
	$sql_r = $conn->query($sql); 
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . ws2html($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	if (showSQL) echo '<br>' . ws2html($sql);
	
	
	// die eigentliche Queries
	$sql = "set @var:=1;";
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . ws2html($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br>' . ws2html($sql);

	$sql = "set @kont='';"; 
	$sql = "set @kont='' collate utf8_general_mysql500_ci ; "; 
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . ws2html($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br>' . ws2html($sql);

	// es wird alles in eine Temporäre Tabelle geschrieben
	
	$sql = ""
	     . " CREATE TABLE ".TableName." \n"
		 
		 . "SELECT \n"
		 . "\tf1.kontinent \n"
		 . "\t,f2.Pos AS Pos \n"
		 . "\t,f1.name \n"
		 . "\t,f1.Abflussmenge \n"
		 . "FROM flussliste AS F1 \n"		 

		 . "INNER JOIN \n"
		 . "(\n"
		 . "\tSELECT \n"
		 . "\t\tkontinent, \n"
		 . "\t\tif (@kont=kontinent,@var:=@var+1,@var:=1) as Pos, \n"
		 . "\t\t(@kont:=kontinent), \n"
		 . "\t\tname, \n"
		 . "\t\tAbflussmenge \n"
		 . "\tFROM flussliste \n"
		 . "\tORDER BY Kontinent, Abflussmenge desc \n"
		 . ") AS F2 \n"
		 . "ON F1.kontinent = f2.kontinent AND  F1.name = F2.name AND F2.pos <= 5  \n"
		 		 		 		 		 		 		 		 
		 . "ORDER BY kontinent, pos   \n"
		 . "";
		 
		 
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br>' . ws2html($sql) . '<br>';
	
	// es wird aus dieser temporären Tabelle ausgelesen
	$sql = ""
		 . "SELECT F1.Kontinent, F1.Pos, F1.Name, F1.Abflussmenge, CntKont FROM ".TableName." AS F1, \n"
		 . "(SELECT COUNT(kontinent) AS CntKont, kontinent \n"
		 . "FROM ".TableName." "
		 . " GROUP BY kontinent) AS F2 \n"
		 . "WHERE F1.kontinent = F2.kontinent \n"
		 . "GROUP BY kontinent, name   \n"
		 . "ORDER BY kontinent, pos   \n"
		 . "";

	// Das Ergebnis der Query wird in Tabellenform ausgegeben	
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br>' . ws2html($sql) . '<br>';
	// Das Ergebnis der Query wird in Tabellenform ausgegeben	
	printTable($sql_r,$tab,$tabClose);

	
	// Das Ergebnis der Query wird in Tabellenform ausgegeben	
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . nl2br($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br>' . ws2html($sql) . '<br>';
	// Das Ergebnis der Query wird in Tabellenform ausgegeben	
	echo $tab.'<tr><th>Kontinent</th><th>Pos</th><th>Name</th><th>Abflussmenge</th></tr>';
	for ($kont='';$sql_row = $sql_r->fetch_array(MYSQLI_ASSOC);$header = 0) 
	{
		if ($kont!=$sql_row['Kontinent'])
			echo '<td rowspan='.$sql_row['CntKont'].'>'.$sql_row['Kontinent'].'</td>';			
		echo printNumberORStr($sql_row['Pos']);
		echo printNumberORStr($sql_row['Name']);
		echo printNumberORStr($sql_row['Abflussmenge']);
		$kont=$sql_row['Kontinent'];		
		echo '</tr>';

		echo '<tr>';
	}

	if ($header) echo $tab.'<tr><th>No record found</th></tr>';
	echo $tabClose.'<p>';		

	// die temporären Tabelle wird gelöscht - eigentlich nicht notwendig, weil dies bei Beendigung des Scripts automatisch gemacht wird
	$sql = "DROP TABLE ".TableName." "; 
	$sql_r = $conn->query($sql); 
	// Abfrage auf einen Fehler - und wenn wird das Script beendet und der Fehler mitgeteilt	
	if($sql_r === false) trigger_error(_ERROR_TEXT_1 . ws2html($sql) . _ERROR_TEXT_1A. $conn->error._ERROR_TEXT_1B, E_USER_ERROR);
	// Das SQL-Statement kann auch ausgegeben werden	
	if (showSQL) echo '<br>' . ws2html($sql);

	// Die Verbindung zur Datenbank wird beendet	
	$conn->close();


?>

 </body>
</html>